#ifndef SQLPARSER_INDEX_TYPE_H
#define SQLPARSER_INDEX_TYPE_H

#include <ostream>

namespace hsql {
  enum class IndexDataStructureType {
    BTREE,
    HASHTABLE,
    SKIPLIST
  };

  struct IndexType {
    IndexType() = default;
    IndexType(IndexDataStructureType data_structure_type_, bool is_unique_) 
    	: data_structure_type(data_structure_type_), is_unique(is_unique_) { }
	IndexType& operator=(const IndexType&) = default;
	~IndexType() = default;
    IndexDataStructureType data_structure_type;
    bool is_unique;
  };

  bool operator==(const IndexType& lhs, const IndexType& rhs);
  bool operator!=(const IndexType& lhs, const IndexType& rhs);
  std::ostream& operator<<(std::ostream&, const IndexType&);

} // namespace hsql

#endif
